index 591593d..d4229ba 100644
--- a/Doc/Zsh/zle.yo
+++ b/Doc/Zsh/zle.yo
@@ -887,6 +887,11 @@ If they do not exist, no special action is taken.  The environment
 provided is identical to that for any other editing widget.
 
 startitem()
+tindex(zle-set-highlight)
+item(tt(zle-set-highlight))(
+Executed every time the line editor prepares to highlight the current
+line (in preparation for outputting changes).
+
 tindex(zle-isearch-exit)
 item(tt(zle-isearch-exit))(
 Executed at the end of incremental search at the point where the isearch
index 3b60285..a9f4d7a 100644
--- a/Src/Zle/zle_refresh.c
+++ b/Src/Zle/zle_refresh.c
@@ -343,6 +343,10 @@ zle_set_highlight(void)
     int isearch_atr_on_set = 0;
     int suffix_atr_on_set = 0;
     struct region_highlight *rhp;
+    int save_lastcmd = lastcmd;
+
+    zlecallhook("zle-set-highlight", NULL);
+    lastcmd = save_lastcmd;
 
     special_atr_on = default_atr_on = 0;
     if (!region_highlights) {
